//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E22F1FD03E1.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E22F1FD03E1.cm

//## begin module%3E22F1FD03E1.cp preserve=no
//## end module%3E22F1FD03E1.cp

//## Module: PlotCommandCreator%3E22F1FD03E1; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotCommandCreator.cxx

//## begin module%3E22F1FD03E1.additionalIncludes preserve=no
//## end module%3E22F1FD03E1.additionalIncludes

//## begin module%3E22F1FD03E1.includes preserve=yes
#include <XSUtil/Parse/XSparse.h>
#include <XSPlot/Commands/ContourPlot.h>
#include <XSPlot/Commands/PlotBackground.h>
#include <XSPlot/Commands/PlotChiSq.h>
#include <XSPlot/Commands/PlotData.h>
#include <XSPlot/Commands/PlotDelchi.h>
#include <XSPlot/Commands/PlotDem.h>
#include <XSPlot/Commands/PlotEfficiency.h>
#include <XSPlot/Commands/PlotFoldmodel.h>
#include <XSPlot/Commands/PlotIcounts.h>
#include <XSPlot/Commands/PlotInsensitivity.h>
#include <XSPlot/Commands/PlotMcmc.h>
#include <XSPlot/Commands/PlotModel.h>
#include <XSPlot/Commands/PlotRatio.h>
#include <XSPlot/Commands/PlotResiduals.h>
#include <XSPlot/Commands/PlotSensitivity.h>
#include <XSPlot/Commands/PlotSum.h>
#include <XSPlot/Commands/PlotUnfolded.h>
//## end module%3E22F1FD03E1.includes

// PlotCommand
#include <XSPlot/Plot/PlotCommand.h>
// PlotCommandCreator
#include <XSPlot/Plot/PlotCommandCreator.h>


//## begin module%3E22F1FD03E1.declarations preserve=no
//## end module%3E22F1FD03E1.declarations

//## begin module%3E22F1FD03E1.additionalDeclarations preserve=yes
#include <sstream>
#include <iomanip>
#include <iterator>
//## end module%3E22F1FD03E1.additionalDeclarations


// Class PlotCommandCreator 

//## begin PlotCommandCreator::commands%4AC65D30035F.role preserve=no  public: static PlotCommand { -> 1..nRFHgN}
PlotCommandContainer PlotCommandCreator::s_commands;
//## end PlotCommandCreator::commands%4AC65D30035F.role

PlotCommandCreator::~PlotCommandCreator()
{
  //## begin PlotCommandCreator::~PlotCommandCreator%3E22F571022C_dest.body preserve=yes
  //## end PlotCommandCreator::~PlotCommandCreator%3E22F571022C_dest.body
}



//## Other Operations (implementation)
string PlotCommandCreator::registerPlotCommands ()
{
  //## begin PlotCommandCreator::registerPlotCommands%3E23089E0218.body preserve=yes
  // Initialize the command map
  using namespace std;
  ostringstream commands;
  commands.setf(ios_base::left,ios_base::adjustfield);
  size_t fieldWidth(15);
  
  s_commands["background"] = new PlotBackground();
  commands << setw(fieldWidth) << "background";
  
  s_commands["chain"] = new PlotMcmc();
  commands << setw(fieldWidth) << "chain";
  
  s_commands["chisq"] = new PlotChiSq();
  commands << setw(fieldWidth) << "chisq";
  
  s_commands["contour"] = new ContourPlot<Step>();
  commands << setw(fieldWidth) << "contour";
  
  s_commands["counts"] = new PlotData("counts",true);
  commands << setw(fieldWidth) << "counts";
  
  s_commands["data"] = new PlotData("data",false);
  commands << setw(fieldWidth) << "data";
  
  s_commands["delchi"] = new PlotDelchi();
  commands << setw(fieldWidth) << "delchi";

  s_commands["dem"] = new PlotDem();
  commands << setw(fieldWidth) << "dem";
  
  s_commands["emodel"] = new PlotModel("emodel");
  commands << setw(fieldWidth) << "emodel";
  
  s_commands["eemodel"] = new PlotModel("eemodel");
  commands << setw(fieldWidth) << "eemodel";
  
  s_commands["efficiency"] = new PlotEfficiency();
  commands << setw(fieldWidth) << "efficiency";
  
  s_commands["eufspec"] = new PlotUnfolded("eufspec");
  commands << setw(fieldWidth) << "eufspec";
  
  s_commands["eeufspec"] = new PlotUnfolded("eeufspec");
  commands << setw(fieldWidth) << "eeufspec";
  
  s_commands["foldmodel"] = new PlotFoldmodel();
  commands << setw(fieldWidth) << "foldmodel";
  
  s_commands["icounts"] = new PlotIcounts();
  commands << setw(fieldWidth) << "icounts";
  
  s_commands["insensitivity"] = new PlotInsensitivity();
  commands << setw(fieldWidth) << "insensitivity";
  
  s_commands["lcounts"] = new PlotData("lcounts",true);
  commands << setw(fieldWidth) << "lcounts";
  
  s_commands["ldata"] = new PlotData("ldata",false);
  commands << setw(fieldWidth) << "ldata";
  
  s_commands["margin"] = new ContourPlot<MarginGrid>();
  commands << setw(fieldWidth) << "margin";
  
  s_commands["model"] = new PlotModel("model");
  commands << setw(fieldWidth) << "model";
  
  s_commands["ratio"] = new PlotRatio();
  commands << setw(fieldWidth) << "ratio";
  
  s_commands["residuals"] = new PlotResiduals();
  commands << setw(fieldWidth) << "residuals";
  
  s_commands["sensitivity"] = new PlotSensitivity();
  commands << setw(fieldWidth) << "sensitivity";
  
  s_commands["sum"] = new PlotSum();
  commands << setw(fieldWidth) << "sum";
  
  s_commands["ufspec"] = new PlotUnfolded("ufspec");
  commands << setw(fieldWidth) << "ufspec";
  
  return commands.str();
  
  //## end PlotCommandCreator::registerPlotCommands%3E23089E0218.body
}

PlotCommand* PlotCommandCreator::commands (const std::string& name)
{
  //## begin PlotCommandCreator::commands%3E2311A60317.body preserve=yes
   PlotCommand* requested(0);
   PC_Iter  iCl (s_commands.lower_bound(name));
   if ( iCl != s_commands.end())  
   {
      if (iCl->first.find(name) == 0)
      {   
	 requested = iCl->second;
      }
   }
   return requested;
  //## end PlotCommandCreator::commands%3E2311A60317.body
}

void PlotCommandCreator::destroy ()
{
  //## begin PlotCommandCreator::destroy%3E23208800BD.body preserve=yes
  PlotCommandContainer::iterator iC = s_commands.begin();
  PlotCommandContainer::iterator iCEnd = s_commands.end();
  while (iC != iCEnd)
  {
     if (iC->second)
     {
        delete iC->second;
     }
     ++iC;
  }
  s_commands.clear();
  //## end PlotCommandCreator::destroy%3E23208800BD.body
}

StringArray PlotCommandCreator::commandNames ()
{
  //## begin PlotCommandCreator::commandNames%3EF9F80C0061.body preserve=yes
  PlotCommandContainer::iterator iC = s_commands.begin();
  PlotCommandContainer::iterator iCEnd = s_commands.end();
  StringArray listOfNames(s_commands.size(),"");
  size_t j(0);
  while (iC != iCEnd)
  {
     listOfNames[j] = iC->first;
     ++iC;
  }

  return listOfNames;
  //## end PlotCommandCreator::commandNames%3EF9F80C0061.body
}

// Additional Declarations
  //## begin PlotCommandCreator%3E22F571022C.declarations preserve=yes
  //## end PlotCommandCreator%3E22F571022C.declarations

//## begin module%3E22F1FD03E1.epilog preserve=yes
//## end module%3E22F1FD03E1.epilog
